using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductGalleries;
namespace CMSMicroservice.Protobuf.Validator.ProductGalleries;

public class GetProductGalleriesRequestValidator : AbstractValidator<GetProductGalleriesRequest>
{
    public GetProductGalleriesRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetProductGalleriesRequest>.CreateWithOptions((GetProductGalleriesRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
